import terrascript.core as core


@core.resource(type="aws_dx_lag", namespace="direct_connect")
class DxLag(core.Resource):

    arn: str | core.StringOut = core.attr(str, computed=True)

    connection_id: str | core.StringOut | None = core.attr(str, default=None)

    connections_bandwidth: str | core.StringOut = core.attr(str)

    force_destroy: bool | core.BoolOut | None = core.attr(bool, default=None)

    has_logical_redundancy: str | core.StringOut = core.attr(str, computed=True)

    id: str | core.StringOut = core.attr(str, computed=True)

    jumbo_frame_capable: bool | core.BoolOut = core.attr(bool, computed=True)

    location: str | core.StringOut = core.attr(str)

    name: str | core.StringOut = core.attr(str)

    owner_account_id: str | core.StringOut = core.attr(str, computed=True)

    provider_name: str | core.StringOut | None = core.attr(str, default=None, computed=True)

    tags: dict[str, str] | core.MapOut[core.StringOut] | None = core.attr(
        str, default=None, kind=core.Kind.map
    )

    tags_all: dict[str, str] | core.MapOut[core.StringOut] | None = core.attr(
        str, default=None, computed=True, kind=core.Kind.map
    )

    def __init__(
        self,
        resource_name: str,
        *,
        connections_bandwidth: str | core.StringOut,
        location: str | core.StringOut,
        name: str | core.StringOut,
        connection_id: str | core.StringOut | None = None,
        force_destroy: bool | core.BoolOut | None = None,
        provider_name: str | core.StringOut | None = None,
        tags: dict[str, str] | core.MapOut[core.StringOut] | None = None,
        tags_all: dict[str, str] | core.MapOut[core.StringOut] | None = None,
        depends_on: list[str] | core.ArrayOut[core.StringOut] | None = None,
        provider: str | core.StringOut | None = None,
        lifecycle: core.Lifecycle | None = None,
    ):
        super().__init__(
            name=resource_name,
            args=DxLag.Args(
                connections_bandwidth=connections_bandwidth,
                location=location,
                name=name,
                connection_id=connection_id,
                force_destroy=force_destroy,
                provider_name=provider_name,
                tags=tags,
                tags_all=tags_all,
                depends_on=depends_on,
                provider=provider,
                lifecycle=lifecycle,
            ),
        )

    @core.schema_args
    class Args(core.Resource.Args):
        connection_id: str | core.StringOut | None = core.arg(default=None)

        connections_bandwidth: str | core.StringOut = core.arg()

        force_destroy: bool | core.BoolOut | None = core.arg(default=None)

        location: str | core.StringOut = core.arg()

        name: str | core.StringOut = core.arg()

        provider_name: str | core.StringOut | None = core.arg(default=None)

        tags: dict[str, str] | core.MapOut[core.StringOut] | None = core.arg(default=None)

        tags_all: dict[str, str] | core.MapOut[core.StringOut] | None = core.arg(default=None)
