import terrascript.core as core


@core.data(type="aws_default_tags", namespace="meta_data_sources")
class DsDefaultTags(core.Data):

    id: str | core.StringOut = core.attr(str, computed=True)

    """
    Blocks of default tags set on the provider. See details below.
    """
    tags: dict[str, str] | core.MapOut[core.StringOut] | None = core.attr(
        str, default=None, computed=True, kind=core.Kind.map
    )

    def __init__(
        self,
        data_name: str,
        *,
        tags: dict[str, str] | core.MapOut[core.StringOut] | None = None,
    ):
        super().__init__(
            name=data_name,
            args=DsDefaultTags.Args(
                tags=tags,
            ),
        )

    @core.schema_args
    class Args(core.SchemaArgs):
        tags: dict[str, str] | core.MapOut[core.StringOut] | None = core.arg(default=None)
